<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBasicPeriod ArrayType
 * @subpackage Arrays
 */
class ArrayOfBasicPeriod extends AbstractStructArrayBase
{
    /**
     * The BasicPeriod
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BasicPeriod[]
     */
    public $BasicPeriod;
    /**
     * Constructor method for ArrayOfBasicPeriod
     * @uses ArrayOfBasicPeriod::setBasicPeriod()
     * @param \StructType\BasicPeriod[] $basicPeriod
     */
    public function __construct(array $basicPeriod = array())
    {
        $this
            ->setBasicPeriod($basicPeriod);
    }
    /**
     * Get BasicPeriod value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BasicPeriod[]|null
     */
    public function getBasicPeriod()
    {
        return isset($this->BasicPeriod) ? $this->BasicPeriod : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBasicPeriod method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBasicPeriod method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBasicPeriodForArrayConstraintsFromSetBasicPeriod(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBasicPeriodBasicPeriodItem) {
            // validation for constraint: itemType
            if (!$arrayOfBasicPeriodBasicPeriodItem instanceof \StructType\BasicPeriod) {
                $invalidValues[] = is_object($arrayOfBasicPeriodBasicPeriodItem) ? get_class($arrayOfBasicPeriodBasicPeriodItem) : sprintf('%s(%s)', gettype($arrayOfBasicPeriodBasicPeriodItem), var_export($arrayOfBasicPeriodBasicPeriodItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BasicPeriod property can only contain items of type \StructType\BasicPeriod, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BasicPeriod value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\BasicPeriod[] $basicPeriod
     * @return \ArrayType\ArrayOfBasicPeriod
     */
    public function setBasicPeriod(array $basicPeriod = array())
    {
        // validation for constraint: array
        if ('' !== ($basicPeriodArrayErrorMessage = self::validateBasicPeriodForArrayConstraintsFromSetBasicPeriod($basicPeriod))) {
            throw new \InvalidArgumentException($basicPeriodArrayErrorMessage, __LINE__);
        }
        if (is_null($basicPeriod) || (is_array($basicPeriod) && empty($basicPeriod))) {
            unset($this->BasicPeriod);
        } else {
            $this->BasicPeriod = $basicPeriod;
        }
        return $this;
    }
    /**
     * Add item to BasicPeriod value
     * @throws \InvalidArgumentException
     * @param \StructType\BasicPeriod $item
     * @return \ArrayType\ArrayOfBasicPeriod
     */
    public function addToBasicPeriod(\StructType\BasicPeriod $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BasicPeriod) {
            throw new \InvalidArgumentException(sprintf('The BasicPeriod property can only contain items of type \StructType\BasicPeriod, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BasicPeriod[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\BasicPeriod|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\BasicPeriod|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\BasicPeriod|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\BasicPeriod|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\BasicPeriod|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BasicPeriod
     */
    public function getAttributeName()
    {
        return 'BasicPeriod';
    }
}
