<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEstablishmentMainFeature ArrayType
 * @subpackage Arrays
 */
class ArrayOfEstablishmentMainFeature extends AbstractStructArrayBase
{
    /**
     * The EstablishmentMainFeature
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $EstablishmentMainFeature;
    /**
     * Constructor method for ArrayOfEstablishmentMainFeature
     * @uses ArrayOfEstablishmentMainFeature::setEstablishmentMainFeature()
     * @param string[] $establishmentMainFeature
     */
    public function __construct(array $establishmentMainFeature = array())
    {
        $this
            ->setEstablishmentMainFeature($establishmentMainFeature);
    }
    /**
     * Get EstablishmentMainFeature value
     * @return string[]|null
     */
    public function getEstablishmentMainFeature()
    {
        return $this->EstablishmentMainFeature;
    }
    /**
     * This method is responsible for validating the values passed to the setEstablishmentMainFeature method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEstablishmentMainFeature method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEstablishmentMainFeatureForArrayConstraintsFromSetEstablishmentMainFeature(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEstablishmentMainFeatureEstablishmentMainFeatureItem) {
            // validation for constraint: enumeration
            if (!\EnumType\EstablishmentMainFeature::valueIsValid($arrayOfEstablishmentMainFeatureEstablishmentMainFeatureItem)) {
                $invalidValues[] = is_object($arrayOfEstablishmentMainFeatureEstablishmentMainFeatureItem) ? get_class($arrayOfEstablishmentMainFeatureEstablishmentMainFeatureItem) : sprintf('%s(%s)', gettype($arrayOfEstablishmentMainFeatureEstablishmentMainFeatureItem), var_export($arrayOfEstablishmentMainFeatureEstablishmentMainFeatureItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\EstablishmentMainFeature', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\EstablishmentMainFeature::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EstablishmentMainFeature value
     * @uses \EnumType\EstablishmentMainFeature::valueIsValid()
     * @uses \EnumType\EstablishmentMainFeature::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $establishmentMainFeature
     * @return \ArrayType\ArrayOfEstablishmentMainFeature
     */
    public function setEstablishmentMainFeature(array $establishmentMainFeature = array())
    {
        // validation for constraint: array
        if ('' !== ($establishmentMainFeatureArrayErrorMessage = self::validateEstablishmentMainFeatureForArrayConstraintsFromSetEstablishmentMainFeature($establishmentMainFeature))) {
            throw new \InvalidArgumentException($establishmentMainFeatureArrayErrorMessage, __LINE__);
        }
        $this->EstablishmentMainFeature = $establishmentMainFeature;
        return $this;
    }
    /**
     * Add item to EstablishmentMainFeature value
     * @uses \EnumType\EstablishmentMainFeature::valueIsValid()
     * @uses \EnumType\EstablishmentMainFeature::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfEstablishmentMainFeature
     */
    public function addToEstablishmentMainFeature($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\EstablishmentMainFeature::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\EstablishmentMainFeature', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\EstablishmentMainFeature::getValidValues())), __LINE__);
        }
        $this->EstablishmentMainFeature[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\EstablishmentMainFeature::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfEstablishmentMainFeature
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\EstablishmentMainFeature::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\EstablishmentMainFeature', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\EstablishmentMainFeature::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EstablishmentMainFeature
     */
    public function getAttributeName()
    {
        return 'EstablishmentMainFeature';
    }
}
