<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProductWeekEndPrice ArrayType
 * @subpackage Arrays
 */
class ArrayOfProductWeekEndPrice extends AbstractStructArrayBase
{
    /**
     * The productWeekEndPrice
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProductWeekEndPrice[]
     */
    public $productWeekEndPrice;
    /**
     * Constructor method for ArrayOfProductWeekEndPrice
     * @uses ArrayOfProductWeekEndPrice::setProductWeekEndPrice()
     * @param \StructType\ProductWeekEndPrice[] $productWeekEndPrice
     */
    public function __construct(array $productWeekEndPrice = array())
    {
        $this
            ->setProductWeekEndPrice($productWeekEndPrice);
    }
    /**
     * Get productWeekEndPrice value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProductWeekEndPrice[]|null
     */
    public function getProductWeekEndPrice()
    {
        return isset($this->productWeekEndPrice) ? $this->productWeekEndPrice : null;
    }
    /**
     * This method is responsible for validating the values passed to the setProductWeekEndPrice method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProductWeekEndPrice method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProductWeekEndPriceForArrayConstraintsFromSetProductWeekEndPrice(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfProductWeekEndPriceProductWeekEndPriceItem) {
            // validation for constraint: itemType
            if (!$arrayOfProductWeekEndPriceProductWeekEndPriceItem instanceof \StructType\ProductWeekEndPrice) {
                $invalidValues[] = is_object($arrayOfProductWeekEndPriceProductWeekEndPriceItem) ? get_class($arrayOfProductWeekEndPriceProductWeekEndPriceItem) : sprintf('%s(%s)', gettype($arrayOfProductWeekEndPriceProductWeekEndPriceItem), var_export($arrayOfProductWeekEndPriceProductWeekEndPriceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The productWeekEndPrice property can only contain items of type \StructType\ProductWeekEndPrice, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set productWeekEndPrice value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ProductWeekEndPrice[] $productWeekEndPrice
     * @return \ArrayType\ArrayOfProductWeekEndPrice
     */
    public function setProductWeekEndPrice(array $productWeekEndPrice = array())
    {
        // validation for constraint: array
        if ('' !== ($productWeekEndPriceArrayErrorMessage = self::validateProductWeekEndPriceForArrayConstraintsFromSetProductWeekEndPrice($productWeekEndPrice))) {
            throw new \InvalidArgumentException($productWeekEndPriceArrayErrorMessage, __LINE__);
        }
        if (is_null($productWeekEndPrice) || (is_array($productWeekEndPrice) && empty($productWeekEndPrice))) {
            unset($this->productWeekEndPrice);
        } else {
            $this->productWeekEndPrice = $productWeekEndPrice;
        }
        return $this;
    }
    /**
     * Add item to productWeekEndPrice value
     * @throws \InvalidArgumentException
     * @param \StructType\ProductWeekEndPrice $item
     * @return \ArrayType\ArrayOfProductWeekEndPrice
     */
    public function addToProductWeekEndPrice(\StructType\ProductWeekEndPrice $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProductWeekEndPrice) {
            throw new \InvalidArgumentException(sprintf('The productWeekEndPrice property can only contain items of type \StructType\ProductWeekEndPrice, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->productWeekEndPrice[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProductWeekEndPrice|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProductWeekEndPrice|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProductWeekEndPrice|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProductWeekEndPrice|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProductWeekEndPrice|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string productWeekEndPrice
     */
    public function getAttributeName()
    {
        return 'productWeekEndPrice';
    }
}
