<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProductUpdatedOn StructType
 * @subpackage Structs
 */
class ProductUpdatedOn extends BaseUpdatedOn
{
    /**
     * The Inventory
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $Inventory;
    /**
     * The TariffGrids
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $TariffGrids;
    /**
     * The Plannings
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $Plannings;
    /**
     * Constructor method for ProductUpdatedOn
     * @uses ProductUpdatedOn::setInventory()
     * @uses ProductUpdatedOn::setTariffGrids()
     * @uses ProductUpdatedOn::setPlannings()
     * @param string $inventory
     * @param string $tariffGrids
     * @param string $plannings
     */
    public function __construct($inventory = null, $tariffGrids = null, $plannings = null)
    {
        $this
            ->setInventory($inventory)
            ->setTariffGrids($tariffGrids)
            ->setPlannings($plannings);
    }
    /**
     * Get Inventory value
     * @return string
     */
    public function getInventory()
    {
        return $this->Inventory;
    }
    /**
     * Set Inventory value
     * @param string $inventory
     * @return \StructType\ProductUpdatedOn
     */
    public function setInventory($inventory = null)
    {
        // validation for constraint: string
        if (!is_null($inventory) && !is_string($inventory)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($inventory, true), gettype($inventory)), __LINE__);
        }
        $this->Inventory = $inventory;
        return $this;
    }
    /**
     * Get TariffGrids value
     * @return string
     */
    public function getTariffGrids()
    {
        return $this->TariffGrids;
    }
    /**
     * Set TariffGrids value
     * @param string $tariffGrids
     * @return \StructType\ProductUpdatedOn
     */
    public function setTariffGrids($tariffGrids = null)
    {
        // validation for constraint: string
        if (!is_null($tariffGrids) && !is_string($tariffGrids)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tariffGrids, true), gettype($tariffGrids)), __LINE__);
        }
        $this->TariffGrids = $tariffGrids;
        return $this;
    }
    /**
     * Get Plannings value
     * @return string
     */
    public function getPlannings()
    {
        return $this->Plannings;
    }
    /**
     * Set Plannings value
     * @param string $plannings
     * @return \StructType\ProductUpdatedOn
     */
    public function setPlannings($plannings = null)
    {
        // validation for constraint: string
        if (!is_null($plannings) && !is_string($plannings)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($plannings, true), gettype($plannings)), __LINE__);
        }
        $this->Plannings = $plannings;
        return $this;
    }
}
